class GestureInventory extends Inventory;

//***variables for spawning effect when hand draws on screen
var vector spawnTemp, spawnTo, playerCamLoc; //temp vector for ScreenToWorld, spawnTo for final location
var xEmitter gEffect; //gesture effect actor
var xEmitter hEffect; //hold effect actor
var grabinPawn P; //the pawn this actor belongs to
var Interaction gInteraction;	//interaction for gesturing
var bool cClick, cDraw, doDrawSnd; //if Rmouse is held, if Lmouse is held, if draw sound plays
var bool assignInt; //true if interaction hasnt been assigned yet
var gestureInter ir;
var grabinController PC; 
//these 2 to make manipulation more painless

//===================================
//======AUXILIARY FUNCTIONS==========
//===================================

//replication
//{
//	reliable if (ROLE == ROLE_Authority)
	//	P, PC, gEffect, hEffect, gInteraction, ir, cClick, cDraw;
//}

simulated function timer()
{	
	if (gInteraction == none)
		assignInt = true;
	if (assignInt == true)
	{
		getInteraction();
		ir = gestureInter(gInteraction);
		assignInt = false;
	} else {
	if ( PC != none )	//no bot support for gestures yet, also prevents spectator tick
	{
		//log("TICKTICKTICK :: :: " $ ir);
		if(cClick)
   		{
			P.AmbientSound = Sound'gestureFX.gesture';
			//play sndFX
			drawing();
			if (!cDraw)
				drawCursor(); //only draw cursor when not actually drawing shapes
		} else {
			P.AmbientSound = none;
		}
   		if (cDraw)
  		{
   				//dont need drawing() here anymore, cant draw without click.
   			drawEffect();
   				//draw effect onscreen
   		}
   				
		if ( doDrawSnd == true ) //set by interaction
		{
			P.PlaySound(Sound'gestureFX.cast', SLOT_None,255,,128,,true);
			doDrawSnd = false;
				//reset so it doesnt loop sounds
		}
	    	if (P.Weapon.isA('sword'))
	    	{
	    		PC.bBehindView = True;
	    		P.bSpecialCalcView = True;
		}
	    	else {
	    		PC.bBehindView = False;
	    		P.bSpecialCalcView = False;
	    	}
	}
	}
}

simulated function setupGesture()
{	
	setBase(P);	//set the inv to follow pawn
	PC = grabinController(P.Controller);
	//log("PC IS! " $ PC);
	//log("PAWN IS! " $ P);
	SetTimer(0.03,true);
}

simulated function getInteraction()
{
	local PlayerController PCn;
	local int i; //iterator
	
	foreach DynamicActors(class'PlayerController', PCn)
	{
		if ( Viewport(PCn.Player) != None )
        	{
        		for (i = 0; i < PCn.Player.LocalInteractions.Length; i++)
            		{
            			if ( PCn.Player.LocalInteractions[i].IsA('gestureInter') )
            				gInteraction = PCn.Player.LocalInteractions[i];
            		}
            	}
        }
}

//===================================
//======EFFECT RENDERING FUNCTIONS===
//===================================

function drawing()
{
	playerCamLoc = P.Location + P.EyePosition();
   		//set location of player cam before function execution
	spawnTemp.X = PC.Player.WindowsMouseX;
   	spawnTemp.Y = PC.Player.WindowsMouseY;
   		//vector to spawn effect to in relation to camera
   	spawnTo = ir.ScreenToWorld(spawnTemp,playerCamLoc,) + (5 * vector(P.GetViewRotation()));
}

function drawEffect()
{
		//spawn effect at world center (effect should have warmup time)
	gEffect = spawn(Class'gestureDrawFX',self,,spawnTo,);
   		//move effect to absolute coords
   	gEffect.Move(gEffect.Location + playerCamLoc);
   	gEffect.bUpdateSimulatedPosition = True;
   	randomiseFX();
}

function drawCursor()
{
	hEffect = spawn(Class'gestureCursorFX',self,,spawnTo,);
	hEffect.Move(hEffect.Location + playerCamLoc);
	hEffect.bUpdateSimulatedPosition = True;
}

function randomiseFX()
{
	//this function just randomises the gesture particle FX a little in color and size
	if (rand(10) == 1)
   	{
   		gEffect.mSizeRange[0]=2.000000;
   		gEffect.mSizeRange[1]=5.000000;
   	}
   	if (rand(4) == 1)
   		gEffect.skins[0]=Texture'EmitterTextures.Flares.EflareP2';
}

defaultproperties
{
	doDrawSnd=false
}
