Class grabinPawn extends xPawn;

#exec AUDIO IMPORT FILE="gesture.WAV" NAME="gesture" GROUP="gestureFX"
#exec AUDIO IMPORT FILE="cast.WAV" NAME="cast" GROUP="gestureFX"
#exec OBJ LOAD FILE=..\Textures\EmitterTextures.utx

const FilterFrames = 5;
var int NextHistorySlot;
var bool bHistoryWarmup;
var vector CameraHistory[FilterFrames]; //vars for special behindview
var gestureInventory GestureInv; //the class that handles all gesturing

replication
{
	reliable if (ROLE == ROLE_Authority)
		giveGesture;
}

	//no more variable to reference PC since it holds nothing now

//iterator to return client's ACTUAL playerController, dont need it yet.
/*simulated function Controller GetLocalPlayerController()
{
    local Controller PCon;

    if ( Level.NetMode == NM_DedicatedServer )
        return None;
	
    foreach DynamicActors(class'Controller', PCon)
        if ( PCon.Pawn == self )
            return PCon;

    return None;
}*/

simulated function bool SpecialCalcView(out actor ViewActor, out vector CameraLocation, out rotator CameraRotation )
{
	local vector CamLookAt, HitLocation, HitNormal;
	local PlayerController pc;
	local int i, averageOver;

	pc = PlayerController(Controller);

	// Only do this mode we have a playercontroller viewing this vehicle
	if(pc == None || pc.ViewTarget != self)
		return false;

	ViewActor = self;
	CamLookAt = Location + (vect(-100, 0, 100) >> Rotation);

	//////////////////////////////////////////////////////
	// Smooth lookat position over a few frames.
	CameraHistory[NextHistorySlot] = CamLookAt;
	NextHistorySlot++;

	if(bHistoryWarmup)
		averageOver = NextHistorySlot;
	else
		averageOver = FilterFrames;

	CamLookAt = vect(0, 0, 0);
	for(i=0; i<averageOver; i++)
		CamLookAt += CameraHistory[i];

	CamLookAt /= float(averageOver);

	if(NextHistorySlot == FilterFrames)
	{
		NextHistorySlot = 0;
		bHistoryWarmup=false;
	}
	//////////////////////////////////////////////////////

	CameraLocation = CamLookAt + (vect(-200, 0, 0) >> CameraRotation);

	if( Trace( HitLocation, HitNormal, CameraLocation, CamLookAt, false, vect(10, 10, 10) ) != None )
	{
		CameraLocation = HitLocation;
	}

	return true;
}

simulated function GiveGesture(string aClassName )
{
	local class<gestureInventory> InvClass;
	
	InvClass = class<gestureInventory>(DynamicLoadObject(aClassName, class'Class'));
	//log("UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUURGH");
	if( FindInventoryType(InvClass) != None )
		return;
	GestureInv = Spawn(InvClass);
	if( GestureInv != None )
	{
		//log("FEEDED " $ GestureInv);
		GestureInv.GiveTo(self);
		GestureInv.P = self;  //assignment so that inv class can reference back easily
		GestureInv.SetupGesture();
	}
}

defaultproperties
{
	bFullVolume=true
	SoundOcclusion=OCCLUSION_BSP
	SoundRadius=128
	SoundVolume=255
	bHistoryWarmup=True
	//RequiredEquipment[0]="grabin.grabinGestureGun"
	//RequiredEquipment[1]="grabin.sword" //dont need now since we do it in mutator
}