//=============================================================================
// s_Spurt.
// $Id: s_Spurt.uc,v 1.2 2003/08/07 23:09:26 jb Exp $
//=============================================================================
class s_Spurt extends Xemitter;

// Maybe Add Nice sloppy drippy gooey ambient sound to this..?

var Class<Actor>    BloodDecalClass;
var texture Splats[3];

simulated function PostNetBeginPlay()
{
    if ( Level.NetMode != NM_DedicatedServer )
        WallSplat();
      SetTimer(LifeSpan - 3.0,false);
    Super.PostNetBeginPlay();
}

simulated function WallSplat()
{
    local vector WallHit, WallNormal;
    local Actor WallActor;

    if ( (FRand() > 0.8) || (BloodDecalClass == None) )
        return;
    WallActor = Trace(WallHit, WallNormal, Location + 200 * vector(Rotation), Location, false);
    if ( WallActor != None )
        spawn(BloodDecalClass,,,WallHit + 20 * (WallNormal + VRand()), rotator(-WallNormal));
}

static function PrecacheContent(LevelInfo Level)
{
    local int i;

    Super.PrecacheContent(Level);
    if ( Default.BloodDecalClass != None )
    {
        for ( i=0; i<3; i++ )
            Level.AddPrecacheMaterial(Default.splats[i]);
    }
}
state Ticking
{
    simulated function Tick( float dt )
    {
        if( LifeSpan < 3.0 )
        {
            mRegenRange[0] *= LifeSpan / 3;
            mRegenRange[1] = mRegenRange[0];


        }
    }
}

simulated function timer()
{

    GotoState('Ticking');

}

defaultproperties
{
     BloodDecalClass=Class'XEffects.BloodSplatter'
     Splats(0)=Texture'BloodFX.Decals.BloodSplat1'
     Splats(1)=Texture'BloodFX.Decals.BloodSplat2'
     Splats(2)=Texture'BloodFX.Decals.BloodSplat3'
     mStartParticles=4
     mMaxParticles=300
     mLifeRange(0)=2.000000
     mRegenRange(0)=300.000000
     mRegenRange(1)=300.000000
     bSuspendWhenNotVisible=False
     mSpeedRange(0)=200.000000
     mSpeedRange(1)=300.000000
     mMassRange(0)=0.400000
     mMassRange(1)=0.500000
     mAirResistance=0.600000
     mSizeRange(0)=5.500000
     mSizeRange(1)=8.500000
     mGrowthRate=1.200000
     mRandTextures=True
     mNumTileColumns=4
     mNumTileRows=4
     bAlwaysRelevant=True
     LifeSpan=8.500000
     Skins(0)=Texture'XEffects.Skins.pcl_Blooda'
     Style=STY_Alpha
}
