//=============================================================================
// sword
// Used by the s_Melee when we can not use the more ehnaced vrs
// of Melee combat.
// $Id: sword.uc,v 1.8 2003/12/04 04:04:23 jb Exp $
//=============================================================================
class sword extends s_Melee config(user);


#EXEC OBJ LOAD FILE=InterfaceContent.utx

simulated function PostNetBeginPlay()
{
    Super.PostNetBeginPlay();

    if ( (Role < ROLE_Authority) && (Instigator != None) && (Instigator.Controller != None) && (Instigator.Weapon != self) && (Instigator.PendingWeapon != self) )
        Instigator.Controller.ClientSwitchToBestWeapon();
}

simulated function DrawWeaponInfo(Canvas Canvas)
{
    local int i,Count;
    local float ScaleFactor;

    Count = Min(8,Ammo[1].AmmoAmount);
    ScaleFactor = 99 * Canvas.ClipX/1600;
    Canvas.Style = ERenderStyle.STY_Alpha;
    Canvas.DrawColor = class'HUD'.Default.WhiteColor;

    for( i=0; i<Count; i++ )
    {
        Canvas.SetPos(Canvas.ClipX - (0.5*i+1) * ScaleFactor, 0.75 * Canvas.ClipY);
        Canvas.DrawTile( Material'InterfaceContent.Hud.SkinA', ScaleFactor, ScaleFactor, 0, 520, 99, 99);
    }
}

function byte BestMode()
{
    if ( (FRand() < 0.1) && (Ammo[1].AmmoAmount >= FireMode[1].AmmoPerFire) )
        return 1;
    if ( Ammo[0].AmmoAmount >= FireMode[0].AmmoPerFire )
        return 0;
    return 1;
}

simulated function float ChargeBar()
{
    return FMin(1,FireMode[1].HoldTime/AssaultGrenade(FireMode[1]).mHoldClampMax);
}

function float SuggestAttackStyle()
{
    return 0.8;
}

function float SuggestDefenseStyle()
{
    return -0.8;
}
    //  EffectOffset=(X=100.0,Y=25.0,Z=-10.0)

defaultproperties
{
     BlockSound(0)=none
     BlockSound(1)=none
     BlockSound(2)=none
     BlockSound(3)=none
     BlockSound(4)=none
     BlockSound(5)=none
     blockrange=-0.640000
     FireModeClass(0)=Class'swordFire'
     FireModeClass(1)=Class'swordAltFire'
     PutDownAnim="PutDown"
     SelectSound=none
     SelectForce="SwitchToAssaultRifle"
     AIRating=0.350000
     CurrentRating=0.350000
     bMeleeWeapon=True
     DisplayFOV=70.000000
     DefaultPriority=2
     InventoryGroup=1
     bDisplayableInv=False
     PickupClass=Class'SwordPickup'
     PlayerViewOffset=(X=-8.000000,Y=5.000000,Z=-6.000000)
     PlayerViewPivot=(Pitch=400)
     BobDamping=2.200000
     AttachmentClass=Class'SwordAttachment'
     IconMaterial=Texture'InterfaceContent.HUD.SkinA'
     IconCoords=(X1=200,Y1=100,X2=321,Y2=189)
     ItemName="Grabin Sword"
     LightType=LT_Pulse
     LightBrightness=150.000000
     LightRadius=4.000000
     LightHue=30
     LightSaturation=150
     LightPeriod=3
     Mesh=SkeletalMesh'NewWeapons2004.NewTranslauncher_1st'
     UV2Texture=Shader'XGameShaders.WeaponShaders.WeaponEnvShader'
     bCanThrow=False
}
